/*
 * DataStore.java
 *
 * (c) Arcanum
 * http://faqsite.narod.ru
 */

import javax.microedition.rms.*;
import java.io.*;

public class DataStore {

//The store's name
    static final String STR_STORE = "BaseMidl";
    
    RecordStore store;
// Variables to put in the store. The simplest way is to make them as bytes.
    byte byMusic;
    byte bySound;
    byte byVibro;
// The helper function. It's made to put variables in the package
    private byte[] fillStorageData() {
        byte[] data = new byte [3];
        data[0] = byMusic;
        data[1] = bySound;
        data[2] = byVibro;
        return data;
    }
 // Another helper fubction. It unpacks data from the package
    private void parseStorageData(byte[] data) {
        byMusic  = data[0];
        bySound  = data[1];
        byVibro  = data[2];
    }

    public DataStore() {

    }
 // Call it to store settings
     public void saveSettings(boolean bMusic, boolean bSound, boolean bVibro) {
        byMusic = bMusic ? (byte)1 : (byte)0;
        bySound = bSound ? (byte)1 : (byte)0;
        byVibro = bVibro ? (byte)1 : (byte)0;
        openStore();
        saveData();
        closeStore();
    }
 // Call it to load settings    
    public boolean[] loadSettings()
    {
        openStore();
        loadData();
        closeStore();
        boolean data[] = new boolean[3];
        data[0] = byMusic != 0 ? true : false;
        data[1] = bySound != 0 ? true : false;
        data[2] = byVibro != 0 ? true : false;
        return data;
    }
// opens the store or creates it    
    private void openStore() {
        try { 
            try { 
                store = RecordStore.openRecordStore(STR_STORE, false);
            } catch (RecordStoreNotFoundException e) { 
                store = RecordStore.openRecordStore(STR_STORE, true);
                initData();
            }
        } catch(Exception e) { 
            System.out.println("Excpt: openRecordStore()" + e);
        }
    }
// closes the store after the usage    
    private void closeStore() {
        if (store != null) { 
            try { 
                store.closeRecordStore();
            } catch (Exception e) {
                System.out.println("Excpt: closeRecordStore()" + e);
            }
        }
    }
// If storage just created we have to make the record with data    
    private void initData() {
        byMusic = 1;
        bySound = 1;
        byVibro = 1;
        byte[] data = fillStorageData();
        try { 
            store.addRecord(data, 0, data.length);
        } catch (Exception e) {
            System.out.println("Excpt: addRecord()" + e);
        } 

    }
// load data from the store to the variables    
    private void loadData() {
        try { 
            if(store == null)
                openStore();
             parseStorageData(store.getRecord(1));
        } catch (Exception e) {
            System.out.println("Excpt: getRecord()" + e);
        }
   }
// save the variables to the store
    private void saveData() {
        try { 
            byte[] data = fillStorageData();
            if(store == null)
                openStore();          
            store.setRecord(1, data, 0, data.length);
        } catch (Exception e) {
            System.out.println("Excpt: setRecord()" + e);
        }
    }

}
