/*
 * MainCanvas.java
 *
 * (c) Arcanum
 * http://faqsite.narod.ru
 */

import javax.microedition.lcdui.*;
import java.io.*;
public class MainCanvas extends Canvas implements Runnable {
    static Image rollImage;
    static {
        try {
            rollImage = Image.createImage("res/roll.png");
        } catch(Exception e) {
            System.out.println("Excpt: createImage()" + e);
        }
    }
// The clipping area for drawing
    static final int xWnd = 35;
    static final int yWnd = 25;
    static final int wWnd = 32;
    static final int hWnd = 32;

    int y           = yWnd + hWnd;  // start position
    int spinCount   = 0;            // increment it

    Displayable parent;   
    Thread thread;                  // We have to implement a thread for repaint
    boolean bWorking = true;        // for thread working/sleeping
    

    public MainCanvas(Displayable parent) {
        super();
        this.parent = parent;
        
        thread = new Thread(this);
        thread.start();                  
    }
    public void start()
    {
        y           = yWnd + hWnd;  // start position
        spinCount   = 0;            // increment it
        resume();
    }
    synchronized public void resume() {
        bWorking = true;
        notify();        
    }
    
    synchronized public void pause() {
        bWorking = false;
    }
    
    protected void paint(Graphics g) {
    // The imlementation of double buffering
        Image bufImage  = Image.createImage(getWidth(), getHeight());
        Graphics bufGfx = bufImage.getGraphics();
     // We draw offscreen first
        bufGfx.setColor(0xC08000);
        bufGfx.drawRect(xWnd - 1, yWnd - 1, wWnd + 2, hWnd + 2);
        bufGfx.setClip(xWnd, yWnd, wWnd, hWnd);         
        bufGfx.drawImage(rollImage, xWnd, y, Graphics.BOTTOM | Graphics.LEFT);
     // Now flip it to the display
        g.drawImage(bufImage, 0, 0, Graphics.TOP | Graphics.LEFT);
    }
    
    public void run() {
    // Thread working function
    // Thread lives while in that cycle
        while(true) {
            try {
            // Make the pause between the animations. It depends on spinCount
                Thread.sleep(++spinCount / 4);
            // Test for pause condition
                synchronized(this) {
                    while(!bWorking)
                        wait();
                }
            } catch (InterruptedException e){
            }
            repaint();
            serviceRepaints();
    // recalculate the next phase of animation
            y += 1;
            if(y > rollImage.getHeight() + yWnd)
            {
                y = yWnd + hWnd;
            }
        }
    }
    
    protected void keyPressed(int keyCode) {
    // The keyboard handler. Here it's the simply pause with after switching to the parent
        pause();
        Display.getDisplay(BaseMidl.midlet).setCurrent(parent);     
    } 
    
}
