/*
 * SetList.java
 *
 * (c) Arcanum
 * http://faqsite.narod.ru
 */

import javax.microedition.lcdui.*;
import java.io.*;

public class SetList extends List implements CommandListener {
    Displayable parent;
    
    static Image musImage;
    static Image sndImage;
    static Image vbrImage;
    
//Command constants
    static final int CMD_MUS     = 0;
    static final String STR_MUS  = "Music";
    static final int CMD_SND     = 1; 
    static final String STR_SND  = "Sound";
    static final int CMD_VBR     = 2;
    static final String STR_VBR  = "Vibration";
    
    static final String STR_TIT  = "Settings";
    static final String STR_CMD_BACK = "Back";
// the command to return to the parent
    static Command backCommand = new Command(STR_CMD_BACK, Command.BACK, 0);
// Preload the images
    static {
        try {
            musImage    = Image.createImage("res/mus.png");
            sndImage    = Image.createImage("res/snd.png");
            vbrImage    = Image.createImage("res/vbr.png");
        }
        catch(IOException e) {
        }
    }
    
    public SetList(Displayable parent) {
        super(STR_TIT, List.MULTIPLE);
        this.parent = parent;
        
        this.append(STR_MUS, musImage);
        this.append(STR_SND, sndImage);
        this.append(STR_VBR, vbrImage);
// Load settings from data store by the array        
        DataStore data = new DataStore();
        boolean set[] = new boolean[3];
        set = data.loadSettings();
        setSelectedFlags(set);
        
        this.addCommand(backCommand);
        
        setCommandListener(this) ;
   }
    
    public void commandAction(Command cmd, Displayable dspl) {
        if(cmd == List.SELECT_COMMAND)
        {
        // the sample handler. Here it is empty. You can override this.
            int i = getSelectedIndex();
            switch(i)
            {
                case CMD_MUS:
                    break;               
                case CMD_SND:
                     break;
                case CMD_VBR:
                    break;        
                default:
                    break;
            }
        }
        if(cmd == backCommand)
        {
        // save all settings at the exit
            boolean Items[] = new boolean [3]; getSelectedFlags(Items);
            DataStore data = new DataStore();
            data.saveSettings(Items[0], Items[1], Items[2]);
            Display.getDisplay(BaseMidl.midlet).setCurrent(parent);
        }
    }
}
